<template>
  <el-form
    ref="normalBankTransferDepositFormRef"
    status-icon
    label-position="top"
    :model="normalBankTransferDepositFormData"
    :rules="normalBankTransferDepositRules"
    label-width="210px"
    class="px-2 py-6 unset-height"
    style="
      height: 85vh;
      overflow-y: scroll;
      margin-bottom: 5px;
    "
    :validate-on-rule-change="false"
  >
    <div
      v-if="bankTransferDepositTextInfo?.Text.length > 0"
      class="pb-4 text-sm rounded --text2 font-normal"
      v-html="bankTransferDepositTextInfo?.Text"
    ></div>
    <h4 class="mt-4 font-bold">{{ $t("from") }}</h4>
    <h4 class="--text2">{{ $t("bank") }}</h4>
    <div v-if="isFirstTimeDeposit" class="pb-5">
      <ui-radio-group
        v-model="normalBankTransferDepositFormData.selectedPlayerBankOption"
        class="flex flex-wrap gap-3 py-2 select-bank"
        group-name="select-bank"
      >
        <ui-radio-button
          v-for="player in playerBankOptions"
          :key="player.BankName"
          :label="player.BankName"
          :value="player.BankName"
          active-class="selected"
        >
          <ui-check-button
            v-if="!player.BankLogo || player.BankLogo === undefined"
            variant="ICON_AND_TEXT"
            :text="player.BankName"
          />
          <ui-check-button
            v-else
            :img="getImagePathBankLogo(player.BankLogo)"
            style="--height: 3rem"
          />
        </ui-radio-button>
      </ui-radio-group>
    </div>
    <div v-else class="pb-5 w-full">
      <ui-radio-group
        v-model="normalBankTransferDepositFormData.selectedPlayerBankOption"
        class="flex flex-wrap gap-3 py-2 gap-3 select-bank to-bank py-2"
        group-name="select-bank"
      >
        <ui-radio-button
          v-for="(bank, index) in playerBankAfterFirstTimeDeposit"
          :key="index"
          :label="bank.PlayerBankName"
          :value="bank.PlayerBankName"
          active-class="selected"
          class="company-bank-name-radio"
        >
          <ui-check-button
            v-if="!bank.BankLogo || bank.BankLogo === undefined"
            variant="ICON_AND_TEXT"
            :text="bank.PlayerBankName"
          />
          <ui-check-button
            v-else
            :img="getImagePathBankLogo(bank.BankLogo)"
            style="--height: 3rem"
          />
        </ui-radio-button>
      </ui-radio-group>
    </div>
    <el-form-item
      v-if="
        normalBankTransferDepositFormData.selectedPlayerBankOption === 'Other'
      "
      :label="$t('bank_name')"
      prop="customizeBankName"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.customizeBankName"
        v-un-focus
        type="text"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.branchNameSetting"
      :label="$t('BranchName')"
      prop="branchName"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.branchName"
        v-un-focus
        type="text"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.bankAccountNameSetting"
      :label="$t('bank_account_name')" 
      prop="bankAccountName"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.bankAccountName"
        v-un-focus
        type="text"
        :disabled="
          !isFirstTimeDeposit &&
          normalBankTransferDepositFormData.selectedPlayerBankOption !== 'Other' &&
          !isFirstTimeBankAccountNameEmpty
        "
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.bankAccountNumberSetting"
      :label="$t('bank_account_number')" 
      prop="bankAccountNumber"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.bankAccountNumber"
        v-un-focus
        type="text"
        :disabled="
          !isFirstTimeDeposit &&
          normalBankTransferDepositFormData.selectedPlayerBankOption !== 'Other' &&
          !isFirstTimeBankAccountNumberEmpty
        "
        @input="onInputValue($event, normalBankTransferDepositFormData, 'bankAccountNumber')"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.bsbSetting"
      :label="$t('BSB')"
      prop="bsb"
    >
      <el-input
        maxlength="6"
        v-model="normalBankTransferDepositFormData.bsb" id="depositBSB" 
        @input="onInputValue($event, normalBankTransferDepositFormData, 'bsb')"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.payIdSetting"
      :label="$t('PayID')"
      prop="payId"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.payId" id="depositPayId" 
      />
    </el-form-item>
    <el-form-item :label="$t('amount')" prop="amount">
      <el-input
        v-model="normalBankTransferDepositFormData.amount"
        v-un-focus
        @input="onInputValue($event, normalBankTransferDepositFormData, 'amount')"
        :placeholder="amountPlaceholder"
      >
        <template v-if="isNeedToMultiplyByThousand" #append>000</template>
      </el-input>
      <span
        v-if="isNeedToMultiplyByThousand"
        class="order-1 text-xs fc-hint mt-3"
        >{{
          $t(
            `deposit_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
          )
        }}
      </span>
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.slipUploadSetting"
      :label="$t('slip_image')"
      prop="slipUpload"
      class="slip-upload"
    >
      <el-upload
        v-if="selectedTheme === 'peru'"
        ref="uploadSlipImageFRef"
        v-model="normalBankTransferDepositFormData.slipUpload"
        class=""
        :limit="1"
        :on-exceed="handleSlipImageExceed"
        accept=".jpg, .png, .jpeg, .svg"
        :on-change="getSlipImage"
        :on-remove="removeSlipImage"
        :auto-upload="false"
      >
        <el-button plain round type="primary">
          {{ $t("choose_file") }}
        </el-button>
      </el-upload>
      <div v-else class="slip-card">
        <div class="flex flex-col items-center pt-3 gap-2">
          <div class="h-8 w-8">
            <img
              :src="getAssetImage('assets/theme/new_black_theme/upload.png')"
              alt=""
            />
          </div>
          <span class="text-sm font-normal leading-4 --text">{{
            $t("upload_your_image")
          }}</span>
          <el-upload
            ref="uploadSlipImageFRef"
            v-model="normalBankTransferDepositFormData.slipUpload"
            class=""
            :limit="1"
            :on-exceed="handleSlipImageExceed"
            accept=".jpg, .png, .jpeg, .svg"
            :on-change="getSlipImage"
            :on-remove="removeSlipImage"
            :auto-upload="false"
          >
            <el-button plain round type="primary">
              <div class="flex gap-1 items-center">
                <UploadIcon
                  class="w-4 h-4 !fill-[var(--primary)] !stroke-none !mr-0"
                />
                <span>
                  {{ $t("choose_file") }}
                </span>
              </div>
            </el-button>
          </el-upload>
        </div>
      </div>
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.depositTimeSetting"
      class="input-class"
      :label="$t('deposit_time')"
      prop="depositTime"
    >
      <el-date-picker
        v-model="normalBankTransferDepositFormData.depositTime"
        type="datetime"
        format="YYYY-MM-DD h:mm:ss A"
        :placeholder="$t('deposit_time')"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.depositReferenceNumberSetting"
      :label="$t('reference_number')"
      prop="depositReferenceNumber"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.depositReferenceNumber"
        v-un-focus
        type="text"
        :placeholder="$t('reference_number')"
      />
      <span
        v-if="selectedTheme === 'black'"
        class="order-1 mt-3 text-xs fc-hint"
        >{{ $t("reference_number_remark") }}</span
      >
    </el-form-item>
    <h4 class="font-bold">{{ $t("to") }}</h4>
    <label class="--text2">{{ $t("company_bank") }}</label>
    <div class="pb-5">
      <ui-radio-group
        v-model="selectedCompanyBankId"
        class="flex flex-wrap gap-3 select-bank to-bank py-2"
        group-name="select-bank"
      >
        <ui-radio-button
          v-for="companyBank in CompanyBanks"
          :key="companyBank.BankName"
          :label="companyBank.Id"
          :value="companyBank.Id"
          active-class="selected"
          class="company-bank-name-radio"
        >
          <ui-check-button
            v-if="!companyBank.BankLogo || companyBank.BankLogo === undefined"
            variant="ICON_AND_TEXT"
            :text="companyBank.BankName"
          />
          <ui-check-button
            v-else
            :img="getImagePathBankLogo(companyBank.BankLogo)"
            style="--height: 3rem"
          />
        </ui-radio-button>
      </ui-radio-group>
    </div>
    <el-form-item
      v-if="companyFlowSettings.companyBankAccountNameSetting"
      :label="$t('CompanyBankAccountName')"
      prop="companyBankAccountName"
      class="isDisabled-container"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.companyBankAccountName"
        v-un-focus
        type="text"
        :disabled="true"
      />
    </el-form-item>
    <el-form-item
      :class="selectedTheme === 'peru' ? 'bank-account' : ''"
      class="isDisabled-container"
      :label="$t('bank_account')"
      prop="companyBankAccountNumber"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.companyBankAccountNumber"
        v-un-focus
        type="text"
        :disabled="true"
      >
        <template #suffix>
          <span
            :class="selectedTheme === 'peru' ? 'hidden' : 'flex items-center'"
            @click="
              copyTextToClipBoard(
                normalBankTransferDepositFormData.companyBankAccountNumber
              )
            "
          >
            {{ $t("copy") }}
          </span>
        </template>
      </el-input>
      <el-button
        v-if="selectedTheme === 'peru'"
        :type="'primary'"
        class="btn-copy flex items-center h-11"
        @click="
          copyTextToClipBoard(
            normalBankTransferDepositFormData.companyBankAccountNumber
          )
        "
      >
        {{ $t("copy") }}
      </el-button>
    </el-form-item>
    <div class="text-center mt-5 buttonSubmitInDeposit submit-button-deposit">
      <el-button
        v-if="isUploadImage"
        type="primary"
        :disabled="isUploadImage"
        round
        @click="submitDepositBankTransfer(normalBankTransferDepositFormRef)"
        >{{ $t("waiting_upload_image") }}</el-button
      >
      <el-button
        v-else-if="isProccesing"
        type="primary"
        :disabled="isProccesing"
        round
        @click="submitDepositBankTransfer(normalBankTransferDepositFormRef)"
        >{{ $t("submit") }}</el-button
      >
      <el-button
        v-else
        type="primary"
        round
        @click="submitDepositBankTransfer(normalBankTransferDepositFormRef)"
        >{{ $t("submit") }}</el-button
      >
    </div>
  </el-form>
</template>
<script lang="ts">
import { defineComponent, PropType, toRefs } from "vue";
import { IGetTransactionBankListResponse } from "@/models/getTransactionBankListResponse";
import { ProfileDto } from "@/models/getProfileResponse";
import { store } from "@/store";
import depositBankImageHelper from "@/utils/depositBankImageHelper";
import UploadIcon from "~/assets/icons/upload_icon.svg?component";

const { getImagePathBankLogo } = depositBankImageHelper;

export default defineComponent({
  name: "NormalBankTransferDeposit",
  props: {
    normalBanks: {
      type: Object as PropType<IGetTransactionBankListResponse>,
      required: true,
      default: {} as IGetTransactionBankListResponse,
    },
    profile: {
      type: Object as PropType<ProfileDto>,
      required: true,
      default: {} as ProfileDto,
    },
  },
  components: {
    UploadIcon,
  },
  setup(props) {
    const { normalBanks, profile } = toRefs(props);
    const selectedTheme = computed(() => store.state.selectedThemeName);
    const {
      getSlipImage,
      removeSlipImage,
      uploadSlipImageFRef,
      copyTextToClipBoard,
      handleSlipImageExceed,
      onInputValue,
      allowCompany,
    } = commonHelper;
    const {
      selectedCompanyBankId,
      companyFlowSettings,
      isFirstTimeDeposit,
      playerBankOptions,
      CompanyBanks,
      playerBankAfterFirstTimeDeposit,
      normalBankTransferDepositRules,
      normalBankTransferDepositFormRef,
      normalBankTransferDepositFormData,
      slipUpload,
      isNeedToMultiplyByThousand,
      isProccesing,
      isUploadImage,
      amountPlaceholder,
      submitDepositBankTransfer,
      bankTransferDepositTextInfo,
      isFirstTimeBankAccountNameEmpty,
      isFirstTimeBankAccountNumberEmpty
    } = useNormalBankTransferDeposit(normalBanks, profile);

    const { getAssetImage } = commonHelper;
    const data = {
      selectedCompanyBankId,
      companyFlowSettings,
      isFirstTimeDeposit,
      playerBankOptions,
      CompanyBanks,
      playerBankAfterFirstTimeDeposit,
      normalBankTransferDepositRules,
      normalBankTransferDepositFormRef,
      normalBankTransferDepositFormData,
      submitDepositBankTransfer,
      copyTextToClipBoard,
      handleSlipImageExceed,
      uploadSlipImageFRef,
      getSlipImage,
      slipUpload,
      removeSlipImage,
      isNeedToMultiplyByThousand,
      isProccesing,
      isUploadImage,
      amountPlaceholder,
      bankTransferDepositTextInfo,
      getAssetImage,
      selectedTheme,
      getImagePathBankLogo,
      onInputValue,
      allowCompany,
      isFirstTimeBankAccountNameEmpty,
      isFirstTimeBankAccountNumberEmpty
    };
    return data;
  },
});
</script>

<style scoped>
.slip-card {
  width: 100%;
  height: 132px;

  /* KR Theme/Background1 */

  background: var(--background1);
  /* KR Theme/Border */

  border: 1px dashed #4d5080;
  border-radius: 8px;
}
:deep(.slip-card button.el-button) {
  width: 152px;
  height: 40px;
  background: transparent !important;
  color: var(--primary) !important;
}
:deep(.el-input__suffix) {
  color: var(--secondary);
}
:deep(.el-input__inner) {
  height: 48px;
  border-radius: 8px;
}
:deep(.bank-account .el-form-item__content) {
  display: flex;
  flex-wrap: nowrap;
}
.btn-copy {
  height: 45px;
}
:deep(.el-select .el-input .el-select__caret) {
  transform: rotateZ(0deg);
}
:deep(.el-select .el-input .el-select__caret.is-reverse) {
  transform: rotateZ(180deg);
}
@media screen and (min-width: 640px) {
  .slip-upload {
    display: flex !important;
    align-items: center;
  }
}
</style>
<style lang="scss">
.ui-radio-group.select-bank {
  .check-btn__img {
    min-width: max-content;
    max-height: 32px;
    img {
      max-height: 32px;
    }
  }
  .selected .check-btn__content {
    --content-padding: 0.5rem 2.5rem 0.5rem 1rem;
    border: 1px solid var(--primary);
    border-radius: 8px;
  }
  .check-btn__content {
    --content-padding: 0.5rem 1rem 0.5rem 1rem;
  }
}
[layout="peru"] {
  .ui-radio-group.select-bank {
    .check-btn__img {
      min-width: max-content;
      max-height: 32px;
      img {
        max-height: 32px;
      }
    }
    .selected .check-btn__content {
      --content-padding: 0.5rem 2.5rem 0.5rem 1rem;
    }
    .check-btn__content {
      --content-padding: 0.5rem 1rem 0.5rem 1rem;
    }
    @media screen and (max-width: 639px) {
      .check-btn__img {
        display: block;
      }
    }
  }
}
.buttonSubmitInDeposit {
  .el-button {
    width: 152px;
    height: 40px;
    span {
      font-size: 14px;
      font-weight: 700;
    }
  }
  .slip-upload {
    display: flex;
  }
}
</style>
